package com.evermind.ejb.taglib;

import javax.ejb.*;
import javax.naming.*;
import javax.servlet.jsp.tagext.*;

/**
 * UseHomeTEI
 * 
 * @author Magnus Stenman
 */
public class UseHomeTEI extends TagExtraInfo
{
    public VariableInfo[] getVariableInfo(TagData data)
	{
		String type = (String)data.getAttribute("type");
		
		if(type == null)
		{
			EJBMetaData metaData = getEJBMetaData((String)data.getAttribute("location"));
			
			if(metaData != null)
				type = metaData.getHomeInterfaceClass().getName();
			else
				throw new RuntimeException("Unable to determine type of EJBHome at location '" + (String)data.getAttribute("location"));
		}

		VariableInfo info = new VariableInfo(data.getId(), type, true, VariableInfo.AT_END);
		VariableInfo[] back = { info };
		return back;
	}

	public static EJBMetaData getEJBMetaData(String location)
	{
		try
		{
			EJBHome home = (EJBHome)javax.rmi.PortableRemoteObject.narrow(new InitialContext().lookup(location), EJBHome.class);
			return home.getEJBMetaData();
		}
		catch(ClassCastException e)
		{
		}
		catch(NamingException e)
		{
		}
		catch(java.rmi.RemoteException e)
		{
		}
		
		return null;
	}
}
