package com.evermind.ejb.taglib;

import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

/**
 * UseHomeTag
 * 
 * @author Magnus Stenman
 */
public class UseHomeTag extends TagSupport
{
	private String location;
	private String type;

	public void setLocation(String location)
	{
		this.location = location;
	}

	public void setType(String type)
	{
		this.type = type;
	}

	public int doStartTag() throws JspException
	{
		try
		{
			InitialContext context = new InitialContext();
		
			EJBHome homeInstance = (EJBHome)PortableRemoteObject.narrow((EJBHome)context.lookup(location), Class.forName(type, true, pageContext.getPage().getClass().getClassLoader()));
			pageContext.setAttribute(this.getId(), homeInstance);
		
			return EVAL_BODY_INCLUDE;
		}
		catch(NamingException e)
		{
			throw new JspException("NamingException: " + e.getMessage());
		}
		catch(ClassNotFoundException e)
		{
			throw new JspException("ClassNotFoundException: " + e.getMessage());
		}
	}
}
